/***************************************************************************
                           DScalerFilterGreedy2frame.h
                           ---------------------------
    begin                : Fri Jun 18 2004
    copyright            : (C) 2004 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
***************************************************************************/

/*
 * Greedy2Frame algorithm taken from DScaler.
 * Copyright (c) 2000 John Adcock, Tom Barry, Steve Grimm  All rights reserved.
 *
 * Warning: Compiling with "-fomit-frame-pointer" will NOT work!
 *
 * Ported by: Dirk Ziegelmeier
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 */

#ifndef DSCALERFILTERGREEDY2FRAME_H
#define DSCALERFILTERGREEDY2FRAME_H

#include <kdetvdscalerfilter.h>

#define LUMATHRESHOLD_DEFAULT   4
#define CHROMATHRESHOLD_DEFAULT 8

class DScalerFilterGreedy2Frame : public KdetvDScalerFilter
{
public:
    DScalerFilterGreedy2Frame();
    virtual ~DScalerFilterGreedy2Frame();

    virtual void filterDScaler_3DNOW(TDeinterlaceInfo* pInfo);
    virtual void filterDScaler_MMX(TDeinterlaceInfo* pInfo);
    virtual void filterDScaler_SSE(TDeinterlaceInfo* pInfo);

    long _lumaThreshold;
    long _chromaThreshold;
};

#endif
