// -*- c++ -*-
/***************************************************************************
                           sharpness.h
                           -----------
    begin                : Sat Jul 31 2004
    copyright            : (C) 2004 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
 ***************************************************************************/

/*
 * Sharpness algorithm taken from DScaler.
 * Copyright (c) 2001 Tom Barry. All rights reserved.
 *
 * Ported by: Dirk Ziegelmeier
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 */

#ifndef SHARPNESS_H
#define SHARPNESS_H

#include <kdetvfilterplugin.h>

class QSpinBox;
class QCheckBox;

class SharpnessPlugin : public KdetvFilterPlugin
{
    Q_OBJECT


public:
    SharpnessPlugin(Kdetv* ktv, const QString& cfgkey, QObject* parent = 0, const char* name=0);
    virtual ~SharpnessPlugin();

    virtual QWidget* configWidget(QWidget *parent, const char *name);
    virtual void saveConfig();


private slots:
    void defaults();


private:
    QSpinBox*  _spSharpness;
    QCheckBox* _cbPrefetch;
};

#endif // SHARPNESS_H
